
#include "conf.hpp"

Conf::Conf() {

}

Conf::~Conf() {

}

int Conf::enumToByteArray(unsigned char *buf, int offset, uint32_t enumeration) {
    return uint32ToByteArray(buf, offset, enumeration) ; // enums are integers in cpp
}

int Conf::uint8ToByteArray(unsigned char *buf, int offset, uint8_t uint8) {
    buf[offset] = (uint8) & 0xFF; offset += 1;
    return offset; // enums are integers in cpp
}

int Conf::uint16ToByteArray(unsigned char *buf, int offset, uint16_t uint16) {
    buf[offset] = (uint16 >> 8) & 0xFF; offset += 1;
    buf[offset] = (uint16 ) & 0xFF; offset += 1;
    return offset; // enums are integers in cpp
}

int Conf::uint32ToByteArray(unsigned char *buf, int offset, uint32_t uint32) {
    buf[offset] = (uint32 >> 24) & 0xFF; offset += 1;
    buf[offset] = (uint32 >> 16) & 0xFF; offset += 1;
    buf[offset] = (uint32 >> 8) & 0xFF; offset += 1;
    buf[offset] = (uint32 ) & 0xFF; offset += 1;
    return offset; // enums are integers in cpp
}

int Conf::stringToByteArray(unsigned char *buf, int offset, string str) {
    for (unsigned int i = 0; i < str.length(); i++) {
        buf[offset] = str.at(i) & 0xFF;
        offset += 1;
    }
    buf[offset] = 0; offset += 1; // null termination
    return offset;
}

int Conf::byteArrayToEnum(unsigned char *buf, int offset, uint32_t &enumeration) {
    return byteArrayToUint32(buf, offset, enumeration);
}

int Conf::byteArrayToUint8(unsigned char *buf, int offset, uint8_t &uint8) {
    uint8 = buf[offset]; offset += 1;
    return offset;
}

int Conf::byteArrayToUint16(unsigned char *buf, int offset, uint16_t &uint16) {
    uint16 = (buf[offset] << 8) | (buf[offset + 1]); offset += 2;
    return offset;
}

int Conf::byteArrayToUint32(unsigned char *buf, int offset, uint32_t &uint32) {
    uint32 = (buf[offset] << 24) | (buf[offset + 1] << 16) | 
             (buf[offset + 2] << 8) | (buf[offset + 3]) ; offset += 4;
    return offset;
}

int Conf::byteArrayToString(unsigned char *buf, int offset, string &str) {
    str = string((char*) (buf + offset)); 
    return offset + str.length() + 1; // add the null terminator
}


