// Configuration mamger is responsible to save and load settings to/from configuration files

#ifndef CONFMGR_H__
#define CONFMGR_H__

#include "common.hpp"
#include "networkconf.hpp"
#include "programconf.hpp"

#define SIGNATURE 0XABCDEFAB // signature
#define SIGNATURELEN 4       // 4 bytes
#define SIZEOFNETWORKCONF 4  // length of network conf -- 4 bytes 

class ConfMgr {
public:    
    ConfMgr(string filename);
    virtual ~ConfMgr();

    void console(); // confmgr implements a simple console interface, 
                    // this function *never* returns
    STATUS load(string newfilename);
    STATUS saveas(string newfilename);
    STATUS save();
    STATUS revert();
    STATUS addProgram(); // add a program with only one primary train. 
                         // more access methods should be added later
    
    // these functions were ported from the Timeslicer file
    inline int getNetBitrate() { return network.getNetBitrate(); };
    inline int getAvailableBitrate() { return network.getAvailableBitrate(); };
    inline int getNetTimePerByte() { return network.getNetTimePerByte(); };
    inline int getAvailableTimePerByte() { return network.getAvailableTimePerByte(); };;

private:
    string lastfilename;            // last configuration file name with path
    NetworkConf network;            // system-wide settings
    vector<ProgramConf> programs; // program-specific setting
    void dump();  // print the curren tsetup...
};


#endif // CONFMGR_H__
