#ifndef PROGRAMCONF_H__
#define PROGRAMCONF_H__

// First byte indicates how many bootTrain follows, which is either 0 or 1, 
// After the bootTrain, a byte indicates how many primaryTrains follows. 
//
// All the trainConf has a uint32 header to indicate its actual length
// 

#include "common.hpp"
#include "trainconf.hpp"
#include "conf.hpp"

#define NUMBOOTTRAINSIZE 1    // whether we have boot train, yes or no
#define NUMPRIMARYTRAINSIZE 1 // no. primary trains is stored in 1-byte
#define TRAINCONFLENSIZE 4    // each train has a 4-byte prefix for actual length

class ProgramConf : public Conf {
    public: 
        ProgramConf();
        ~ProgramConf();
        virtual int getDataLength();  // amount of memory required for seralization
        virtual int fillData(unsigned char *buf, int offset);
        virtual int readData(unsigned char *buf, int offset);
        virtual string toString();
        virtual STATUS set(); // console input method.

    private:
        TrainConf *bootTrain;
        vector<TrainConf> primaryTrains;
};


#endif // PROGRAMCONF_H__
